<template>
  <q-card class="c-col min-w-500px h-full">
    <q-card-section class="bg-secondary text-white">
      <transition
        name="opacity"
        mode="out-in"
      >
        <div
          :key="title"
          class="text-24px !duration-100"
        >
          {{ title }}
        </div>
      </transition>
    </q-card-section>
    <div class="c-col h-full">
      <div class="header c-row p-10px bg-gray-100">
        <div class="text-14px flex-1">
          工作名稱
        </div>
        <div class="text-14px flex-1">
          班別
        </div>
        <div class="text-14px flex-1">
          排班人員
        </div>
      </div>
      <transition
        name="opacity"
        mode="out-in"
      >
        <div
          v-if="targetVacancies.length !== 0"
          :key="title"
          class="body c-col h-full p-10px gap-10px !duration-100"
        >
          <div
            v-for="(vacancy, i) in targetVacancies"
            :key="i"
            class="c-row items-center"
          >
            <div class="text-14px flex-1">
              {{ vacancy.job?.name }}
            </div>
            <div class="text-14px flex-1">
              {{ vacancy.jobType?.name }}
            </div>
            <div class="text-14px flex-1 relative">
              <div
                v-if="!vacancy.executor"
                class="flex items-center text-red absolute-full p-10px pointer-events-none"
              >
                無適合人員
              </div>
              <q-select
                v-model="vacancy.executor"
                :options="staff"
                option-label="name"
                placeholder="無適合人員"
                filled
                dense
              >
                <template #option="scope">
                  <q-item
                    class="min-w-300px"
                    v-bind="scope.itemProps"
                  >
                    <q-item-section avatar>
                      <q-item-label>{{ scope.opt.name }}</q-item-label>
                    </q-item-section>
                    <q-item-section class="px-10px">
                      <q-item-label>班別</q-item-label>
                      <q-item-label class="flex gap-2px">
                        <q-chip
                          v-for="(item, y) in scope.opt.jobTypes"
                          :key="y"
                          color="light-blue-2"
                        >
                          {{ item.name }}
                        </q-chip>
                      </q-item-label>
                    </q-item-section>
                    <q-item-section class="px-10px">
                      <q-item-label>資格</q-item-label>
                      <q-item-label class="c-row gap-2px">
                        <q-chip
                          v-for="item, y in scope.opt.qualifications"
                          :key="y"
                          color="cyan-2"
                        >
                          {{ item.name }}
                        </q-chip>
                      </q-item-label>
                    </q-item-section>
                    <q-item-section class="px-10px">
                      <q-item-label>是否約假</q-item-label>
                      <q-item-label class="c-row gap-2px">
                        <q-chip color="teal-2">
                          {{ isHoliday(scope.opt) }}
                        </q-chip>
                      </q-item-label>
                    </q-item-section>
                  </q-item>
                </template>
              </q-select>
            </div>
          </div>
        </div>
        <div
          v-else
          class="body c-col h-full p-10px gap-10px !duration-100"
        >
          <div class="c-row">
            <div class="text-14px flex-1 text-center">
              無工作
            </div>
          </div>
        </div>
      </transition>
    </div>
  </q-card>
</template>


<script lang='ts' setup>
import { computed, ref } from 'vue';
import { ClassSchedule, StaffMember } from '../../types/main.type';

import { useMainStore } from '../../store/main.store';

interface Props {
  targetDate: string | null;
  classSchedule: ClassSchedule;
}

const props = withDefaults(defineProps<Props>(), {
  /** 目標日期 */
  targetDate: undefined,
  classSchedule: undefined,
});

const store = useMainStore();

const staff = computed(() => store.staff);
const holidays = computed(() => store.holidays);

const title = computed(() => {
  if (!props.classSchedule) {
    return '尚未排定班表';
  }

  if (!props.targetDate) {
    return '選擇想查看工作分配的日期';
  }

  return props.targetDate;
});

const targetVacancies = computed(() => {
  if (!props.targetDate) {
    return [];
  }

  if (!props.classSchedule) {
    return [];
  }

  const target = props.classSchedule.itineraries.find(
    (itinerary) => itinerary.date === props.targetDate
  );

  return target?.vacancies ?? [];
});

function isHoliday(member: StaffMember) {
  const date = props.targetDate;

  const targetDay = holidays.value.find((holiday) => holiday.date === date);
  if (!targetDay) {
    return '沒有';
  }

  return targetDay.member.name === member.name ? '有' : '沒有';
}
</script>
